function createCookie(name, value, days) {
  var expires = "";
  if (days) {
    var date = new Date();
    date.setTime(date.getTime()+(days*24*60*60*1000));
    expires = "; expires=" + date.toString();
  }
  else {
  	expires = "";
  }
  document.cookie = name+"="+value+expires+"; path=/";
}
function readCookie(name) {
  var ca = document.cookie.split(';');
  var nameEQ = name + "=";
  for(var i=0; i < ca.length; i++) {
    var c = ca[i];
    while (c.charAt(0)===' ') { c = c.substring(1, c.length); }
    if (c.indexOf(nameEQ) === 0) { return c.substring(nameEQ.length, c.length); }
  }
  return null;
}
function eraseCookie(name) {
  createCookie(name, "", -1);
}
function getDateString() {
	var dt1 = new Date();
	var dtStr = dt1.getFullYear() + "/" + (dt1.getMonth() + 1) + "/" + dt1.getDate() + " " + 			dt1.getHours() + ":" + dt1.getMinutes() + ":" + dt1.getSeconds() + ":" + dt1.getMilliseconds();
	return dtStr;
}
function trim(str) {
	var a = str.replace(/^\s+/, '');
	return a.replace(/\s+$/, '');
}

function addLoadEvent() {
  var oldonload = window.onload;
  if (typeof window.onload != 'function') {
    window.onload = captureLoadTime;
  } else {
    window.onload = function() {
      if (oldonload) {
        oldonload();
      }
      captureLoadTime();
     }
  }
}
function addOnBeforeUnloadEvent() {
	var oldOnBeforeUnload = window.onbeforeunload;
	window.onbeforeunload = function() {
		var ret;
		if ( oldOnBeforeUnload ) {
			ret = oldOnBeforeUnload();
		}
		captureTimeOnBeforeUnload();
		if ( ret ) return ret;
	}
}
function captureTimeOnBeforeUnload() {
	//alert('captureTimeOnBeforeUnload new--');
	createCookie('pagepostTime', getDateString() );
}
function captureLoadTime() {
	restorePreviousPostTime();
	var docLocation = document.title;
	createCookie('pageLoadName', docLocation );
	createCookie('pageloadTime', getDateString() );
	addOnBeforeUnloadEvent();
	//alert('captureLoadTime new--');
}
function restorePreviousPostTime() {
	var prevPagePostTime = readCookie('pagepostTime');
	createCookie('prevPagePostTime', prevPagePostTime );
}

function captureTimeShowModalDialog() {
	var args = captureTimeShowModalDialog.arguments;
	createCookie('pagepostTime', getDateString());
	if (args.length == 0) return origWindowMD();
	if (args.length == 1) return origWindowMD(args[0]);
	else if (args.length == 2) return origWindowMD(args[0],args[1]);
	else if (args.length == 3) return origWindowMD(args[0],args[1],args[2]);
	else return origWindowMD(args[0],args[1],args[2]);
}

var origWindowMD = window.showModalDialog;
window.showModalDialog = captureTimeShowModalDialog;

function captureTimeWindowOpen() {	
	var args = captureTimeWindowOpen.arguments;
	createCookie('pagepostTime', getDateString());
	if (args.length == 0 ) return origWindowOpen();
	if (args.length == 1) return origWindowOpen(args[0]);
	else if (args.length == 2) return origWindowOpen(args[0],args[1]);
	else if (args.length == 3) return origWindowOpen(args[0],args[1],args[2]);
	else return origWindowOpen(args[0],args[1],args[2]);
}

var origWindowOpen = window.open;
window.open = captureTimeWindowOpen;

/*
 *  The following scripts are the alternate approach to capture server initiation events
 */
/*
function captureSubmit() {	
	try {
		var allForms = document.forms;
		if ( allForms !== null ) {
			for ( var i=0; i < allForms.length; i++) {
				allForms[i].onsubmit = capturePostTimeForSubmit;
			}
		}
	}catch(e){}
	return true;
}
function capturePostTimeForSubmit(event) {
	
	var target = event ? event.target : this;
	var actionValue = "UNKNOWN";
	if ( target.action != null && target.action != "undefined") {
		actionValue = target.action;
		//Now you can write the action in a cookie and send it to server to track
		//alert("Inside capturePostTimeForSubmit --> " + actionValue);
	}
	//old code
	createCookie('pagepostTime', getDateString());
}
function captureJavaScriptSubmit() {
	for (var form, i = 0; (form = document.forms[i]); ++i) {
		form.realSubmit = form.submit
		form.submit = function () {
			capturePostTimeForJavaScriptSubmit(this);
			this.realSubmit();
		}
	}
}
function capturePostTimeForJavaScriptSubmit(aForm) {

	var actionValue = "UNKNOWN";
	if ( aForm.action != null && aForm.action != "undefined") {
		actionValue = aForm.action;
		//Now you can write the action in a cookie and send it to server to track
		//alert("Inside capturePostTimeForJavaScriptSubmit --> " + actionValue);
	}
	//old code
	createCookie('pagepostTime', getDateString());
	return true;
}

function captureLinkClicks() {
	try {
		var links = document.getElementsByTagName('a'); 		
		for (var i = 0; i < links.length; i++) { 
			var hrefString = links[i].href + "";
			if ( hrefString.indexOf("#") == -1 && hrefString !== "" && !hrefContainsScript(hrefString) ) {
				if ( links[i].onclick ) {
					links[i].oldonclick = links[i].onclick;
				}				
				links[i].onclick = function() {
			      var ret = false;	          
			      if (this.oldonclick) {
			        ret = this.oldonclick();
				    if ( false != ret ) {
				    	capturePostTimeForLink(this);
					}
				    return ret;			        
			      }
			      else {
			    	  capturePostTimeForLink(this);
			    	  return true;
			      }			      			      
			    }
			}
		}
	}catch(e){}
	return true;		
}
function hrefContainsScript(hrefString) {
	hrefString = hrefString.toUpperCase();
	hrefString = trim(hrefString);
	if ( hrefString.substring(0,10) == "JAVASCRIPT") {
		return true;
	}
	return false;
}
function capturePostTimeForLink(aLink) {
	//alert('Inside capturePostTimeForLink: ' + aLink.href);
	createCookie('pagepostTime', getDateString());
}
*/

/*
 *  The following scripts are the for AJAX
 */
/*
function captureTimeAJAXSend(vData) {
	createCookie('pagepostTime', getDateString());	
	this.originalSend(vData);
}
function captureTimeAJAXReturn(xmlHttp) {
	//Here you have to capture the load time of ajax return
}
*/
