package com.tcs.tool.filter;

import java.io.IOException;


import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class ScriptInjectionFilter implements Filter {

	private FilterConfig config;

	public ScriptInjectionFilter() {
		super();
	}

	public void init(final FilterConfig filterConfig) throws ServletException {
		this.config = filterConfig;
	}


	public void destroy() {
		config = null;
	}

	public void doFilter(final ServletRequest request, final ServletResponse response,
			final FilterChain chain) throws IOException, ServletException {
		if ( ! (request instanceof HttpServletRequest && response instanceof HttpServletResponse)) {
			chain.doFilter(request, response);
			return;
		}
		HttpServletRequest httpRequest = (HttpServletRequest) request;
		CharResponseWrapper wrappedResponse = new CharResponseWrapper((HttpServletResponse) response);
		try {
			chain.doFilter(request, wrappedResponse);
			byte[] bArray = wrappedResponse.getData();
			//System.out.println("Before:" + String.valueOf(bArray));
			if ( bArray != null && bArray.length > 0 && getShouldInject(wrappedResponse) ) {
				bArray = modifyContent(bArray,httpRequest);
			}
			//System.out.println("After:" +  String.valueOf(bArray));
			if ( bArray != null ) {
				response.getOutputStream().write(bArray);
				response.getOutputStream().close();
			}

		} catch (IOException ioe) {
			throw ioe;
		} catch (ServletException se) {
			throw se;
		} catch (RuntimeException rte) {
			throw rte;
		}
	}

	private static final String startScript1 = "<script language='JavaScript' src='";
	private static final String endScript1 = "/timecapturejs/client_time_capture.js' type='text/javascript'></script>\n";

	//private static final String startScript3 = "<script language='JavaScript'>\ncaptureSubmit();captureJavaScriptSubmit();captureLinkClicks();addLoadEvent();\n</script>\n";
	private static final String startScript2 = "<script language='JavaScript'>\naddLoadEvent();\n</script>\n";

	private byte[] modifyContent(byte[] array, HttpServletRequest httpRequest) {
		String sContent = new String(array);
		StringBuffer sbf = new StringBuffer(sContent);
		sContent = sContent.toLowerCase();

		int indexOfEndHead = sContent.indexOf("</head>");
		if ( indexOfEndHead != -1 ) {
			sbf = sbf.insert(indexOfEndHead, startScript1 + httpRequest.getContextPath() + endScript1);
			int indexOfEndBody = sbf.toString().toLowerCase().indexOf("</body>");
			if ( indexOfEndBody != -1 ) {
				sbf = sbf.insert(indexOfEndBody, startScript2);
				return sbf.toString().getBytes();
			}
			else {
				return array;
			}
		}
		else {
			return array;
		}

	}

	private boolean getShouldInject(ServletResponse response) {

		String contentType = response.getContentType();
		String strContentType = (contentType != null) ? contentType.toLowerCase() : "";
		System.out.println("strContentType=" + strContentType);
		if ((strContentType.indexOf("text/html") == -1) && (strContentType.indexOf("application/xhtml+xml") == -1)) {
			// don't inject anything if the content is not html
			return false;
		}
		return true;
	}

}
